﻿/*
* IFRAO Calibrator
* version 1.0
* Copyright (c) 2013 José Pereira.
* http://www.jpereira.net

 WARNING 
 This is a script for experimental use only, NOT for to calibrate images on production environments.
  If you need to calibrate images with a IFRAO Standard Sacale. Please, consider that it is not a accurate way for calibrate images. 
  However, if you need some test you must set a representative RGB values in the  arraySalida array.  
  
 For use: you must to use the pen tool of PS, for select your color patches, beginning to the blue pach, like this example:

 http://www.jpereira.net/IFRAO-ps-script-download
 
 */

var outPutValues = new Array ;
var docRef = activeDocument;
var profile = docRef.colorProfileName;

//===============================================================
  var arraySalida = new Array();

 //adobe RGB 2001
  arraySalida[0] = Array(75,	72,	115 ); //azul
  arraySalida[1] = Array(73,	141,	85); //verde
  arraySalida[2] = Array(238,	220,	30); //amarillo
  arraySalida[3] = Array(162,	52,	42); //rojo



 // Bednarik 1995
 /* 
  arraySalida[0] = Array(50,0,90); //azul
  arraySalida[1] = Array(0,134,73); //verde
  arraySalida[2] = Array(255,215,0); //amarillo
  arraySalida[3] = Array(214,0,39); //rojo
  */
  
  lengthOfSelectedPathItems();

function lengthOfSelectedPathItems() {

	var X,Y;
	var coordenadas = new Array();
    nmuestras = 4;

    for(h=0; h<  nmuestras; h++) { 
		X = activeDocument.pathItems[0].subPathItems[0].pathPoints[h].anchor[0];
		Y = activeDocument.pathItems[0].subPathItems[0].pathPoints[h].anchor[1];        
         coordenadas[h] =  Array(X,Y);
    }
        activeDocument.pathItems.removeAll(); 
        creaMuestras(coordenadas);
}  
  
//creaMuestras(coordenadas) ;
 
function creaMuestras(coordenadas){
    
    arrayEntrada = new Array();
    for(h=0; h<  coordenadas.length; h++) { 
    colores = getSelectionColor( coordenadas[h][0], coordenadas[h][1], 5 );
    arrayEntrada[h] = Array(colores.rgb.red, colores.rgb.green, colores.rgb.blue );
    //alert( salida[h].toString() );
    }
   //return arrayEntrada;
   lanzaMuestras(arraySalida, arrayEntrada )
} 


function informe(arraySalida, arrayEntrada ){
    
        var Name = app.activeDocument.name.replace(/\.[^\.]+$/, '');
        var Path = app.activeDocument.path;
 
        var f = new File(Path + "/" + Name +"_color_analysis.txt");
         
         f.open("a+");
         f.write ( "\r" ) ;
         f.write ( "IMAGE SUMMARY\r");
         
          for(h=0; h<  arraySalida.length; h++) {
              f.write ( "\r"+arrayEntrada[h].toString()+"\t"+arraySalida[h].toString()+"\r" ) ;
              }
    
    }
 
function lanzaMuestras(arraySalida, arrayEntrada ){ 
 
informe(arraySalida, arrayEntrada ); 
 
    aRed  = new Array();
    aGreen  = new Array();
    aBlue  = new Array(); 
 
   var io = [];
   var j = 0;
   var h = 0;
   for(h=0; h<  arraySalida.length; h++) { 
       io[h] = [];
       for(i=0; i<  3; i++) { 
       io[h][i] = Array( arrayEntrada[h][i],arraySalida[h][i]);
       j++;
       }
   
       }
    
    aRed[0]    = Array(0,0);
    aGreen[0] =  Array(0,0);
    aBlue[0]    =  Array(0,0);

 for(h=0; h<  arraySalida.length; h++) {
     if (io[h][0][0] != 0){
     aRed[h+1]       = Array(io[h][0][0],io[h][0][1] );
     }
     if (io[h][1][0] != 0){
     aGreen[h+1]   =  Array(io[h][1][0], io[h][1][1] );
     }
     if (io[h][2][0] != 0){
     aBlue[h+1]      =  Array(io[h][2][0], io[h][2][1]);
     }
     }
 
     aRed[h+1]    = Array(255,255);
     aGreen[h+1] =  Array(255,255);
     aBlue[h+1]    =  Array(255,255);

     aRed = cleanArray(aRed);
     aGreen = cleanArray(aGreen);
     aBlue = cleanArray(aBlue);


currvesRGB(aBlue,aGreen,aRed);

}

function currvesRGB(aBlue,aGreen,aRed){
    
    var desc2 = new ActionDescriptor();
    var ref1 = new ActionReference();
    ref1.putClass( charIDToTypeID('AdjL') );
    desc2.putReference( charIDToTypeID('null'), ref1 );
    var desc3 = new ActionDescriptor();
    var desc4 = new ActionDescriptor();
    desc4.putEnumerated( stringIDToTypeID('presetKind'), stringIDToTypeID('presetKindType'), stringIDToTypeID('presetKindCustom') );
    var list1 = new ActionList();
    //Red
    var desc5 = new ActionDescriptor();
    var ref2 = new ActionReference();
    ref2.putEnumerated( charIDToTypeID('Chnl'), charIDToTypeID('Chnl'), charIDToTypeID('Rd  ') );
    desc5.putReference( charIDToTypeID('Chnl'), ref2 );
   
   var list2 = new ActionList();
    aRed.sort(function mysortfn(a,b) { return ((parseFloat(a[0]) < parseFloat(b[0])) ? -1 : ((parseFloat(a[0]) > parseFloat(b[0])) ? 1 : 0));});							
    for (var i=0;i<aRed.length;i++) {
    var desc6 = new ActionDescriptor();
    desc6.putDouble( charIDToTypeID('Hrzn'), aRed[i][0] );
    desc6.putDouble( charIDToTypeID('Vrtc'), aRed[i][1] );
    list2.putObject( charIDToTypeID('Pnt '), desc6 );
   }
    
    desc5.putList( charIDToTypeID('Crv '), list2 );
    list1.putObject( charIDToTypeID('CrvA'), desc5 );
    //------------------->Green
    var desc9 = new ActionDescriptor();
    var ref3 = new ActionReference();
    ref3.putEnumerated( charIDToTypeID('Chnl'), charIDToTypeID('Chnl'), charIDToTypeID('Grn ') );
    desc9.putReference( charIDToTypeID('Chnl'), ref3 );
    var list3 = new ActionList();
   aGreen.sort(function mysortfn(a,b) { return ((parseFloat(a[0]) < parseFloat(b[0])) ? -1 : ((parseFloat(a[0]) > parseFloat(b[0])) ? 1 : 0));});							
  for (var i=0;i<aGreen.length;i++){  
    var desc10 = new ActionDescriptor();
    desc10.putDouble( charIDToTypeID('Hrzn'),aGreen[i][0]  );
    desc10.putDouble( charIDToTypeID('Vrtc'),aGreen[i][1] );
    list3.putObject( charIDToTypeID('Pnt '), desc10 );
  }

    desc9.putList( charIDToTypeID('Crv '), list3 );
    list1.putObject( charIDToTypeID('CrvA'), desc9 );
   
   //---------------->Blue
    var desc13 = new ActionDescriptor();
    var ref4 = new ActionReference();
    ref4.putEnumerated( charIDToTypeID('Chnl'), charIDToTypeID('Chnl'), charIDToTypeID('Bl  ') );
    desc13.putReference( charIDToTypeID('Chnl'), ref4 );
    var list4 = new ActionList();
    
   aBlue.sort(function mysortfn(a,b) { return ((parseFloat(a[0]) < parseFloat(b[0])) ? -1 : ((parseFloat(a[0]) > parseFloat(b[0])) ? 1 : 0));});							
    for (var i=0;i<aBlue.length;i++){
        var desc16 = new ActionDescriptor();
        desc16.putDouble( charIDToTypeID('Hrzn'),  aBlue[i][0] );
       desc16.putDouble( charIDToTypeID('Vrtc'),  aBlue[i][1] );
       list4.putObject( charIDToTypeID('Pnt '), desc16 );
     }

    desc13.putList( charIDToTypeID('Crv '), list4 );
    list1.putObject( charIDToTypeID('CrvA'), desc13 );
    desc4.putList( charIDToTypeID('Adjs'), list1 );
    
    desc3.putObject( charIDToTypeID('Type'), charIDToTypeID('Crvs'), desc4 );
    desc2.putObject( charIDToTypeID('Usng'), charIDToTypeID('AdjL'), desc3 );
    executeAction( charIDToTypeID('Mk  '), desc2, DialogModes.NO );
    };

function getSelectionColor( x, y, sampleSize ){
     try{
          x = x - ( sampleSize / 2 );
          y = y - ( sampleSize / 2 );
          activeDocument.selection.select([[x, y], [x+sampleSize, y], [x+sampleSize, y+sampleSize], [x, y+sampleSize]], SelectionType.REPLACE, 0, false);
          activeDocument.activeLayer.applyAverage();
          var re = RegExp( '[123456789]' );
          var sColor = new SolidColor();

          if ( activeDocument.mode == DocumentMode.RGB ) {
              sColor.rgb.red = re.exec(activeDocument.channels[0].histogram.toString() ).index/2;
              sColor.rgb.green = re.exec( activeDocument.channels[1].histogram.toString() ).index/2;
              sColor.rgb.blue = re.exec( activeDocument.channels[2].histogram.toString() ).index/2;
          }
          executeAction( charIDToTypeID('undo'), undefined, DialogModes.NO );
          activeDocument.selection.deselect();
          return sColor;
     }catch(e){}
}

function cleanArray(actual){
  var newArray = new Array();
  for(var i = 0; i<actual.length; i++){
      if (actual[i]){
        newArray.push(actual[i]);
    }
  }
  return newArray;
}







